VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RobotInterface"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Written by David Finch <mef@wave.net>  ICQ #9869494
Option Explicit

Private dbgtext As String
Private indx As Long
Private sc As ScriptControl
Private bot As Robot

Private rbname As String

Public desiredspeed As Long
Public bodyturn As Long
Public gunturn As Long
Public radarturn As Long
Public radararc As Long

Public bodycolor As Long, guncolor As Long, radarcolor As Long

Public Property Get MouseX() As Double
MouseX = amousex
End Property

Public Property Get MouseY() As Double
MouseY = amousey
End Property

Private Function CanFWrite()
If FileRestrict Then
    If gamecount <= 1 And bot.dead Then
        CanFWrite = True
    Else
        CanFWrite = False
    End If
Else
    CanFWrite = True
End If
End Function

Public Property Let name(ByVal a As String)
rbname = a + "." + CStr(indx)
End Property

Public Property Get name() As String
name = rbname
End Property

Public Sub appendfile(ByVal fname As String, ByVal text As String)
If CanFWrite() Then
On Error Resume Next
If InStr(fname, ".") > 0 Or InStr(fname, "/") > 0 Or InStr(fname, ":") > 0 Then Exit Sub
ChDir App.path
Open fname + ".rbf" For Append As #5
Print #5, text;
Close #5
End If
End Sub

Public Function getfile(ByVal fname As String) As String
On Error Resume Next
Dim s As String
If InStr(fname, ".") > 0 Or InStr(fname, "/") > 0 Or InStr(fname, ":") > 0 Then
    s = ""
    Exit Function
End If
ChDir App.path
Open fname + ".rbf" For Input As #5
s = Input$(LOF(1), #1)
Close #5
getfile = s
End Function


Public Sub writefile(ByVal fname As String, ByVal text As String)
If CanFWrite() Then
On Error Resume Next
If InStr(fname, ".") > 0 Or InStr(fname, "/") > 0 Or InStr(fname, ":") > 0 Then Exit Sub
ChDir App.path
Open fname + ".rbf" For Output As #5
Print #5, text;
Close #5
End If
End Sub

Public Sub debugprint(ByVal a As Variant)
If MainForm.WindowState <> 1 Then
MainForm.Label2.Caption = "Robot #" + CStr(indx) + ": " + vbCrLf + CStr(a)
MainForm.Command2_Click
End If
End Sub

Public Sub TellAudience(ByVal a As Variant)
Static p As Long
If p <> gamecount Then
    Dim s As String
    s = CStr(a)
    If Len(s) > 256 Then s = Left$(s, 256)
    broadcast name + " says, """ + s + """"
    p = gamecount
End If
End Sub


'allow robots to transfer energy with 20% waste
Public Sub TransferEnergy(ByVal id As Long, ByVal amount As Double)
If Not NoTransfer Then
If id >= 0 And id < RICount Then
If amount > bot.energy Then amount = bot.energy
If amount > 0 And id <> indx Then
    robots(id).energy = robots(id).energy + amount * 0.8
    bot.energy = bot.energy - amount
End If
End If
End If
End Sub

Public Sub exec(ByVal a As String)
On Error Resume Next
sc.ExecuteStatement a
End Sub

Public Function eval(ByVal a As String) As Variant
On Error Resume Next
eval = sc.eval(a)
End Function

Public Property Get Index()
Index = indx
End Property

Public Property Get ArenaWidth() As Long
ArenaWidth = aWidth
End Property

Public Property Get ArenaHeight() As Long
ArenaHeight = aHeight
End Property

Public Property Get flags() As Long
Static pflags As Long
Static pturns As Long
Dim f As Long

If turns = pturns Then
    flags = pflags
Else
    If bot.dtcrobot Then f = f + 1
    If bot.cldrobot Then f = f + 2
    If bot.cldmissile Then f = f + 4

    pturns = turns
    pflags = f
    flags = f
End If
End Property


Public Property Get XPos() As Double
XPos = bot.x / 65536
End Property

Public Property Get YPos() As Double
YPos = bot.y / 65536
End Property

Public Property Get dtcrobot() As Boolean
dtcrobot = bot.dtcrobot
End Property

Public Property Get cldrobot() As Boolean
cldrobot = bot.cldrobot
End Property

Public Property Get cldmissile() As Boolean
cldmissile = bot.cldmissile
End Property

Public Property Get cldaim() As Long
cldaim = bot.cldaim
End Property

Public Property Get cldid() As Long
cldid = bot.cldid
End Property

Public Property Get cldenergy() As Double
cldenergy = bot.cldenergy
End Property

Public Property Get energy() As Double
energy = bot.energy
End Property

Public Property Get shields() As Double
shields = bot.shields
End Property

Public Property Get gunheat() As Double
gunheat = bot.gunheat
End Property

Public Property Get dtcenergy() As Double
dtcenergy = bot.dtcenergy
End Property

Public Property Get dtcid() As Double
dtcid = bot.dtcid
End Property

Public Property Get scandist() As Double
scandist = bot.scandist
End Property

Public Property Get bodyaim() As Long
bodyaim = bot.bodyaim
End Property

Public Property Get gunaim() As Long
gunaim = bot.gunaim
End Property

Public Property Get radaraim() As Long
radaraim = bot.radaraim
End Property

Public Property Get speed() As Double
speed = bot.speed
End Property

Public Property Get dtcx() As Double
dtcx = bot.dtcx
End Property

Public Property Get dtcy() As Double
dtcy = bot.dtcy
End Property

Public Property Get turncount() As Long
turncount = turns
End Property

Public Property Get GamesLeft() As Long
Dim i As Long
i = gamecount - 1
If i < 0 Then i = 0
GamesLeft = i
End Property

Public Property Get RobotCount() As Long
RobotCount = RICount
End Property

Public Property Get RobotsLeft() As Long
RobotsLeft = livingbots
End Property


Public Function AngleOf(ByVal x As Double, ByVal y As Double) As Double
AngleOf = getangle(x, y)
End Function

Public Function LengthOf(ByVal x As Double, ByVal y As Double) As Double
LengthOf = Sqr(x * x + y * y)
End Function


Public Sub stall(ByVal i As Long)
bot.stall = i
End Sub

Public Sub fire(ByVal nrg As Double, ByVal range As Double)
If Not NoFiring Then
Dim i As Long
Dim n2 As Double
If nrg > bot.energy Then nrg = bot.energy
If nrg > 50 Then nrg = 50
If nrg < 1 Then nrg = 1
n2 = nrg * (2 + (24 - bot.gunheat) / 12)
If n2 < nrg Then Exit Sub
bot.energy = bot.energy - nrg
With missiles(missilecount)
    .aim = bot.gunaim
    .energy = n2
    .id = indx
    .proximity = range + 20
    .x = bot.x + sinlook(bot.gunaim) * 15
    .y = bot.y - coslook(bot.gunaim) * 15
End With
missilecount = missilecount + 1
bot.gunheat = bot.gunheat + 25
ToneOn 1, 60, nrg
ToneOn 0, 45, nrg
MissileFired = True

End If
End Sub

'make robot communication possible
Public Function Request(ByVal id As Long, param As Variant) As Variant
If NoComm Then
    Request = "NOCOMM"
Else
If id < 0 Or id >= RICount Then
    Request = "INVALID"
ElseIf robots(id).stall > 0 Then
    Request = "STALLED " + CStr(robots(id).stall)
ElseIf robots(id).dead Then
    Request = "DEAD"
Else
    bot.energy = bot.energy - 1 'cost to communicate
    'If robots(id).working Then
        On Error Resume Next
        Request = MainForm.sc(id).Run("HandleRequest", indx, param)
        On Error GoTo 0
    'Else
        'Request = "HALTED"
    'End If
End If
End If
End Function

Public Function isFriend(ByVal i As Integer) As Boolean
If i < 0 Or i >= RICount Then
isFriend = False
Else
If team(indx) < 0 Then isFriend = False Else isFriend = (team(indx) = team(i))
End If
End Function

Private Sub Class_Initialize()
indx = RICount
Set sc = MainForm.sc(indx)
sc.UseSafeSubset = Not allowunsafe
Set bot = robots(indx)
sc.reset
sc.AddObject "rba", Me, True
RICount = RICount + 1
name = "Robot"
End Sub

Private Sub Class_Terminate()
On Error Resume Next
sc.reset
Set sc = Nothing
Set bot.sc = Nothing
Set bot = Nothing
Unload MainForm.sc(indx)
On Error GoTo 0
End Sub








