Attribute VB_Name = "GlobalStuff"
'Written by David Finch <mef@wave.net>  ICQ #9869494
Option Explicit

Public trackrobot As Long

Public aWidth As Long
Public aHeight As Long

Public totalgames As Long
Public gamespeed As Long

Public timeout As Long
Public ntimeout As Long

Public amousex As Double, amousey As Double

Public MissileFired As Boolean 'currently used for sound

Public TOrder(100) As Long

Public allowunsafe As Boolean
Public blocktelnet As Boolean
Public logmatch As Boolean
Public sendlog As Boolean
Public recordmatch As Boolean
Public sendrecord As Boolean

Public ForceLockall As Boolean
Public NoCharge As Boolean
Public NoShields As Boolean
Public NoComm As Boolean
Public NoTransfer As Boolean
Public NoFiring As Boolean
Public FrontArmor As Boolean
Public FileRestrict As Boolean
Public ScoringMethod As Long

Public DrawBold As Boolean

Public ARatio As Double
Public Aszm As Double
Public Arena As PictureBox

Public livingbots As Long
Public gamecount As Long

Public tmStart As Boolean

Public s2b(100) As Long
Public b2s(100) As Long
Public wsdata(100) As String
Public linked(100) As Boolean
Public names(100) As String

Public recordgame As Boolean
Public GameRecord(1023) As Byte 'after a block is done, it is written to disk.
Public GameRecordSize As Long
Public RecordFile As String

Type Missile
aim As Long
x As Long
y As Long
ax As Long
ay As Long
energy As Double
id As Long
proximity As Double
End Type

Public RICount As Long

Public running As Boolean

Public turns As Long

Public robots(100) As Robot
Public team(100) As Long
Public missiles(100) As Missile

Public missilecount As Long

Public bcstring As String


'each range from -65536 to 65536
Public sinlook(360) As Long
Public coslook(360) As Long


Public Sub setratio()
ARatio = aWidth / aHeight
If ARatio > 1 Then Aszm = ARatio Else Aszm = 1
End Sub


Public Sub broadcast(s As String)
If recordmatch Or sendrecord Then bcstring = bcstring + s + vbCrLf
Dim i As Long
On Error Resume Next
If logmatch Then
ChDir App.path
Open "vbots.log" For Append As #3
Print #3, s
Close #3
End If
If sendlog Then
For i = 0 To 100
If linked(i) Then
MainForm.rbws(i).SendData s + vbCrLf
DoEvents
End If
Next i
End If
End Sub


Public Function st(a As Variant, b As Variant) As Variant
a = b
st = b
End Function

Public Sub checkteamwin()
Dim i As Long, p As Long
Dim a As Long
p = -1
For i = 0 To RICount - 1
    If Not robots(i).dead Then
        If team(i) < 0 Then Exit Sub
        If team(i) <> p Then
            a = a + 1
            p = team(i)
        End If
    End If
Next i
If a <= 1 And RICount > 1 Then
    While livingbots > 0
        killweakest
    Wend
End If
End Sub

Public Function cleanstr(s As String) As String
Dim t As String
t = Replace(s, vbCr, "")
t = Replace(s, vbLf, "")
If Len(t) > 32 Then t = Left$(t, 32)
cleanstr = t
End Function

Public Sub mslcleanup()
Dim i As Long, i2 As Long
While i < missilecount
If missiles(i).energy > 0 Then
    missiles(i2) = missiles(i)
    i2 = i2 + 1
ElseIf gamespeed >= 0 Then
    drawexplosion missiles(i).ax, missiles(i).ay, 0
    'drawmissile missiles(i).ax, missiles(i).ay, QBColor(15)
End If
i = i + 1
Wend
missilecount = i2
End Sub

Public Sub energyburst(x As Long, y As Long, energy As Double)
    Dim i As Long, d As Double, cx As Double, cy As Double
    For i = 0 To RICount - 1
        With robots(i)
            If Not .dead Then
                cx = (x - .x) / 65536
                cy = (y - .y) / 65536
                d = cx * cx + cy * cy
                If d < 1024 Then d = 1024
                d = energy * 1024 / d
                .energy = .energy + d
            End If
        End With
    Next i
End Sub

Public Sub missiletest()
Dim i As Long, i2 As Long, i3 As Long, d As Double, cx As Long, cy As Long
For i = 0 To missilecount - 1
    With missiles(i)
    If .energy > 0 Then
        For i2 = 0 To RICount - 1
            If .id <> robots(i2).Index Then
                cx = (.x - robots(i2).x) \ 65536
                cy = (.y - robots(i2).y) \ 65536
                d = Sqr(cx * cx + cy * cy)
                If d < .proximity Then
                    For i3 = 0 To RICount - 1 'missile explosions can hit self
                        If Not robots(i3).dead Then
                            cx = (.x - robots(i3).x) \ 65536
                            cy = (.y - robots(i3).y) \ 65536
                            d = cx * cx + cy * cy
                            If d < 289 Then d = 289
                            d = .energy * 289 / d
                            If d > 1 Then
                                robots(i3).cldid = .id
                                robots(i3).cldenergy = d
                                robots(i3).cldmissile = True
                                robots(i3).shields = robots(i3).shields - d
                                robots(i3).energyshield
                            End If
                        End If
                    Next i3
                    .energy = 0
                    Dim xt As Long
                    For xt = 0 To 10
                        DoEvents
                    Next xt
                    If gamespeed >= 0 Then drawexplosion .ax, .ay, 1
                    ToneOn 0, 40, 32
                End If
            End If
        Next i2
    End If
    End With
Next i
'mslcleanup
End Sub

Public Sub drawexplosion(x As Long, y As Long, ByVal color As Long)
    Dim i
    If color Then color = &HBFFF& Else color = QBColor(15)
    MainForm.Picture1.FillStyle = 0
    MainForm.Picture1.FillColor = color
    MainForm.Picture1.Circle (x, y), Aszm * 20, color, , , ARatio
    MainForm.Picture1.FillStyle = 1
End Sub

Public Sub drawmissile(x As Long, y As Long, color As Long)
    If gamespeed >= 0 Then
        If aWidth >= 2000 Then
            If color = QBColor(15) Then
                Arena.Circle (x, y), Aszm * aWidth / 200, QBColor(15), , , ARatio
            Else
                Arena.Circle (x, y), Aszm * aWidth / 200, QBColor(12), , , ARatio
            End If
        Else
            MainForm.Picture1.Circle (x, y), Aszm * 2, color, , , ARatio
        End If
    End If
End Sub

Public Sub updatemissiles()
mslcleanup
Dim i As Long
missiletest
mslcleanup
For i = 0 To missilecount - 1
With missiles(i)
If gamespeed > 0 Or (turns And 1) = 1 Then drawmissile .ax, .ay, QBColor(15)
.x = .x + sinlook(.aim) * 15
.y = .y - coslook(.aim) * 15
.ax = .x \ 65536
.ay = .y \ 65536
If .ax < 0 Or .ay < 0 Or .ax > aWidth Or .ay > aHeight Then
    .energy = 0
End If
If gamespeed > 0 Or (turns And 1) = 0 Then drawmissile .ax, .ay, QBColor(0)
.energy = .energy - 0.5
End With
Next i
missiletest
End Sub

Public Function getfile(path As String) As String
On Error Resume Next
Open path For Input As #2
getfile = Input$(LOF(2), #2)
Close #2
On Error GoTo 0
End Function

Public Sub addrobot(path As String)
If Len(path) > 4 Then
Dim i As Long
i = RICount
Set robots(i) = New Robot
robots(i).loadrobot getfile(path), LCase$(Right$(path, 3))
End If
End Sub

Sub addbyte(ByVal a As Long)
On Error GoTo 0
If a > 255 Then a = 255
If a < 0 Then a = 0
GameRecord(GameRecordSize) = a
GameRecordSize = GameRecordSize + 1
If GameRecordSize >= 1024 Then
    If recordmatch Then
        ChDir App.path
        Open RecordFile For Binary As #4
        Put #4, LOF(4) + 1, GameRecord
        Close #4
    End If
    GameRecordSize = 0
End If
End Sub

Sub FinishRecord()
addbyte 255
addbc
While GameRecordSize > 0
addbyte 255
Wend
End Sub

Sub addbc()
Dim i As Long

For i = 1 To Len(bcstring)
    addbyte Asc(Mid$(bcstring, i, 1))
Next i
bcstring = ""
addbyte 0
End Sub

Sub addrecord()
Dim i As Long
addbyte 17 * 1024 / aWidth
addbyte livingbots
For i = 0 To RICount - 1
    With robots(i)
    If Not .dead Then
        addbyte .x \ (aWidth * 257)
        addbyte .y \ (aHeight * 257)
        addbyte ((.bodyaim * 256 + 127) Mod 92160) \ 360
        addbyte ((.radaraim * 256 + 127) Mod 92160) \ 360
        addbyte ((.gunaim * 256 + 127) Mod 92160) \ 360
    End If
    End With
Next i
addbyte missilecount
For i = 0 To missilecount - 1
    With missiles(i)
        addbyte .x \ (aWidth * 257)
        addbyte .y \ (aHeight * 257)
    End With
Next i
addbc
End Sub


Public Sub game()
MatchResults.Show

timeout = 5000
ntimeout = timeout
RandomOrder

amousex = aWidth / 2
amousey = aHeight / 2

Dim i As Long
turns = 0
'init in random order to ensure more random placement, or else robots 0 and 1 will rarely meet in beginning
MatchResults.FillList
For i = 0 To RICount - 1
robots(TOrder(i)).Init
Next i
livingbots = RICount
running = True
While livingbots > 0
If running Then
    turn
    If recordmatch Or sendrecord Then addrecord
End If
If gamespeed > 0 Then
    For i = 0 To gamespeed: DoEvents: Next i
Else
    DoEvents
End If
Wend
MatchResults.FillList
missilecount = 0
End Sub

Public Sub killweakest()
Dim i As Long
Dim e As Double
Dim em As Double
Dim mi As Long

em = 1000000
For i = 0 To RICount - 1
    With robots(i)
        If Not .dead Then
            e = .energy + .shields + Rnd
            If e < em Then
                em = e
                mi = i
            End If
        End If
    End With
Next i
broadcast robots(mi).interface.name + " vanished."
robots(mi).kill
End Sub

Public Sub turn()
Dim i As Long
checkteamwin
turns = turns + 1
For i = 0 To RICount - 1
robots(TOrder(i)).Core
Next i
If turns > ntimeout Then
    broadcast "Game too long. Removing weakest bot."
    killweakest
    timeout = (timeout + 500) / 2
    ntimeout = ntimeout + timeout
End If
updatemissiles
End Sub

Public Sub wrap(i As Long)
i = (i + 36000) Mod 360
End Sub

Public Function wrap2(i As Long) As Long
wrap2 = (i + 36000) Mod 360
End Function

Public Function getangle(x As Double, y As Double) As Double
Dim a As Double
If y = 0 Then
    If x > 0 Then getangle = 90 Else getangle = 270
ElseIf y < 0 Then
    a = Atn(x / -y) * 180 / 3.1415926535859
    If a < 0 Then a = a + 360
    getangle = a
Else
    getangle = 180 + Atn(x / -y) * 180 / 3.1415926535859
End If
End Function

Public Function dist(a As Long, b As Long) As Double
Dim cx As Double, cy As Double
cx = (robots(a).x - robots(b).x) / 65536
cy = (robots(a).y - robots(b).y) / 65536
dist = Sqr(cx * cx + cy * cy)
End Function

Public Function asin(a As Double) As Double
asin = Atn(a / Sqr(1 - a * a))
End Function

'reduce problems with entry order
Public Sub RandomOrder()
Static t As Double
If RICount <= 1 Then
TOrder(0) = 0
robots(0).TIndex = 0
Exit Sub
End If
t = t + Timer
Randomize t
Dim i As Long
Dim p As Long
If Rnd >= 0.5 Then
TOrder(0) = 0
TOrder(1) = 1
Else
TOrder(0) = 1
TOrder(1) = 0
End If
For i = 2 To RICount - 1
p = Int(Rnd * i)
TOrder(i) = TOrder(p)
TOrder(p) = i
Next i
For i = 0 To RICount - 1
robots(TOrder(i)).TIndex = i
Next i
End Sub
