VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Robot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Written by David Finch <mef@wave.net>  ICQ #9869494
Option Explicit

Public score As Long

Public CLike As Boolean

Public TIndex As Long
Public Index As Long
Public x As Long
Public y As Long

Public working As Boolean

Public shields As Double

Public energy As Double
Public bodyaim As Long
Public gunaim As Long
Public radaraim As Long

Public px As Long
Public py As Long
Public pbodyaim As Long
Public pgunaim As Long
Public pradaraim As Long
Public stall As Long

Public gunheat As Long

Public speed As Double

Public interface As RobotInterface


Public ax As Long
Public ay As Long

Public sc As ScriptControl 'set outside

Public cldaim As Long
Public cldenergy As Double
Public cldid As Long

Public cldrobot As Boolean
'Public cldmine As Boolean
'Public cldcookie As Boolean
Public cldmissile As Boolean
Public dtcrobot As Boolean
Public dtcenergy As Double
Public dtcid As Long

Public dtcx As Double, dtcy As Double

'Public dtcmine As Boolean
'Public dtccookie As Boolean
Public dead As Boolean
Public scandist As Double

'only for use in reset(). only checks previous robots
'Also weighted x and y
Public Function nearest() As Double
Dim i As Long
Dim m As Double
Dim d As Double
m = 1000000
For i = 0 To TIndex - 1
d = dist(Index, TOrder(i))
If d < m Then m = d
Next i
nearest = m
End Function

Public Function nearestx() As Long
Dim i As Long
Dim m As Long
Dim d As Long
m = 1000000
For i = 0 To TIndex - 1
With robots(TOrder(i))
d = Abs(ax - .ax)
End With
If d < m Then m = d
Next i
nearestx = m
End Function


Public Sub reset()
cldid = Index
dead = False
cldrobot = False
cldmissile = False
dtcrobot = False
bodyaim = 0
gunaim = 0
radaraim = 0
cldenergy = 0
cldaim = 0
dtcid = -1
dtcenergy = 0
scandist = 0
gunheat = 0
energy = 1000
If Not NoShields Then shields = 1000
stall = 0
speed = 0
With interface
.bodyturn = 0
.desiredspeed = 0
.gunturn = 0
.radarturn = 0
End With

Dim i As Long, a As Long, x2 As Long, xd As Long, d As Long

i = Sqr(aWidth * aHeight / RICount) * 2
If i < 40 Then i = 40
Do
    If i = 34 Then
        MsgBox "Cannot fit robot #" + CStr(TIndex) + " into this tiny arena."
        End
    End If
    If i > 34 Then i = i - 1
    xd = -1
    x2 = Rnd * (Arena.ScaleWidth - 34) + 17
    For a = 0 To Sqr(i / 8)
        ax = Rnd * (Arena.ScaleWidth - 34) + 17
        d = nearestx()
        If d > xd Then
            xd = d
            x2 = ax
        End If
    Next a
    ax = x2
    ay = Rnd * (Arena.ScaleHeight - 34) + 17
    x = 65536 * ax
    y = 65536 * ay
Loop Until nearest() > i
aWidth = Arena.ScaleWidth
aHeight = Arena.ScaleHeight
End Sub

Public Sub Init()
reset
'If working Then
On Error Resume Next
sc.Run "Init"
On Error GoTo 0
'End If
End Sub

Private Function sq(a As Long) As Long
sq = a * a
End Function

Public Sub kill()
    If livingbots = 1 Then
        broadcast interface.name + " won this game."
    Else
        ToneOn 0, 40, 127

    End If
    
    Dim s As Long
    dead = True
    energy = 0
    eraseRobot
    s = RICount - livingbots
    If RICount = 2 Then
        score = score + s
    Else
        If ScoringMethod = 0 Then score = score + s * 2
        If ScoringMethod = 1 Then score = score + s
    End If
    livingbots = livingbots - 1
'    If working Then
    On Error Resume Next
    sc.Run "Dead"
    On Error GoTo 0
'    End If
    energyburst x, y, 250
End Sub

Public Function energyshield()
If shields < 0 Then
    energy = energy + shields
    shields = 0
End If
End Function

Private Function mdr(a As Long, b As Long)
mdr = ((b - a + 37800) Mod 3600) - 1800
End Function


Public Sub Core()
If Not dead Then
    energyshield
    If energy > 0 Then
        If livingbots = 1 And RICount > 1 Then
            kill
            Exit Sub
        End If
        Dim a As Double
        Dim i As Long
        
        If Not NoCharge Then energy = energy + 1
        If gunheat > 0 Then gunheat = gunheat - 1 - Abs(speed) / 20
        If gunheat < 0 Then gunheat = 0
        'cost to maintain energy shields
        If shields <= 0 Then energy = energy - 1
        
        If energy > 10000 Then energy = 10000
        
        If NoShields Then shields = 0
        
        If stall <= 0 Then
            'scan before calling for most accurate results
            scandist = 1000000
            For i = 0 To RICount - 1
                If i <> Index And Not robots(i).dead Then
                    Dim ag As Long
                    a = getangle(robots(i).x - x, robots(i).y - y)
                    ag = Abs(mdr(radaraim * 10, CLng(a * 10)))
                    If ag < 600 Then
                        Dim d1 As Double, d2 As Double
                        Dim r1 As Double
                        Dim ac As Long
                        Dim sd As Long
                        ac = interface.radararc * 5
                        If ac < 0 Then ac = 0
                        If ac > 75 Then ac = 75
                        d1 = dist(i, Index)
                        If d1 < 18 Then d1 = 18
                        'd2 = Sqr(d1 * d1 - 289)
                        'If d2 < 1 Then d2 = 1
                        'r1 = asin(17 / d2) * 180 / 3.1415926535859
                        r1 = asin(17 / d1) * 180 / 3.1415926535859
                        If ag <= ac + Abs(r1) + 5 Then
                            sd = d1 - 34
                            If sd < scandist Then
                                scandist = sd
                                dtcrobot = True
                                dtcenergy = robots(i).energy
                                dtcid = i
                                dtcx = robots(i).x / 65536
                                dtcy = robots(i).y / 65536
                            End If
                        End If
                    End If
                End If
            Next i
            'If working Then
                On Error Resume Next
                sc.Run "Core"
                On Error GoTo 0
            'Else
                'stall = 1000000
            'End If
            speed = speed * 0.9
            a = interface.desiredspeed - speed
            If a > 1 Then a = 1
            If a < -1 Then a = -1
            energy = energy - Abs(a)
            speed = speed + a
            
            i = interface.bodyturn
            If i > 5 Then i = 5
            If i < -5 Then i = -5
            bodyaim = bodyaim + i
            gunaim = gunaim + i
            radaraim = radaraim + i
            energy = energy - Abs(i) / 20
            If ForceLockall Then
                gunaim = bodyaim
                radaraim = bodyaim
            Else
                i = interface.gunturn
                If i > 10 Then i = 10
                If i < -10 Then i = -10
                gunaim = gunaim + i
                radaraim = radaraim + i
                energy = energy - Abs(i) / 100
                
                i = interface.radarturn
                If i > 15 Then i = 15
                If i < -15 Then i = -15
                radaraim = radaraim + i
                energy = energy - Abs(i) / 150
            End If
        Else
            speed = speed * 0.9
            stall = stall - 1
            If Not NoCharge Then energy = energy + 1 'extra energy because everything is shut off
        End If
        
        wrap bodyaim
        wrap gunaim
        wrap radaraim
        
        x = x + sinlook(bodyaim) * speed
        y = y - coslook(bodyaim) * speed
        ax = x \ 65536
        ay = y \ 65536
        If ax < 17 Then
            shields = shields + ax - 17
            energyshield
            speed = speed / 2
            ax = 17
            x = ax * 65536 + 32767
        ElseIf ax > aWidth - 17 Then
            shields = shields - ax + aWidth - 17
            energyshield
            speed = speed / 2
            ax = aWidth - 17
            x = ax * 65536 + 32767
        End If
        If ay < 17 Then
            shields = shields + ay - 17
            energyshield
            speed = speed / 2
            ay = 17
            y = ay * 65536 + 32767
        ElseIf ay > aHeight - 17 Then
            shields = shields - ay + aHeight - 17
            energyshield
            speed = speed / 2
            ay = aHeight - 17
            y = ay * 65536 + 32767
        End If
        cldrobot = False
        dtcrobot = False
        'cldmine = False
        'dtcmine = False
        'cldcookie = False
        'dtccookie = False
        cldmissile = False
        
        Dim d As Long
        Dim ii As Long
        
        
        For ii = 0 To RICount - 1
            i = TOrder(ii) 'fix entry order crashing problems
            If i <> Index And robots(i).energy > 0 And Not robots(i).dead Then
                With robots(i)
                    If sq(.ax - ax) + sq(.ay - ay) < 1024 Then
                        Dim cx As Double, cy As Double, r As Double, e As Double
                        cx = (.x + x) / 2
                        cy = (.y + y) / 2
                        r = 2359296 / Sqr(CDbl(.x - x) ^ 2 + CDbl(.y - y) ^ 2)
                        .x = CDbl(.x) * r - cx * (r - 1)
                        .y = CDbl(.y) * r - cy * (r - 1)
                        x = CDbl(x) * r - cx * (r - 1)
                        y = CDbl(y) * r - cy * (r - 1)
                        cx = sinlook(bodyaim) * speed - sinlook(.bodyaim) * .speed
                        cy = coslook(bodyaim) * speed - coslook(.bodyaim) * .speed
                        e = Sqr(cx * cx + cy * cy) / 32768
                        .cldid = Index
                        .cldrobot = True
                        .cldaim = getangle(x - .x, y - .y)
                        If FrontArmor Then
                            If Abs(mdr(.cldaim * 10, .bodyaim * 10)) > 450 Then
                                .shields = .shields - e
                            End If
                        Else
                            .shields = .shields - e
                        End If
                        .energyshield
                        .speed = (.speed + .interface.desiredspeed) / 2
                        If .speed < -10 Then .speed = -10
                        If .speed > 10 Then .speed = 10
                        
                        cldid = .Index
                        cldrobot = True
                        cldaim = getangle(.x - x, .y - y)
                        If FrontArmor Then
                            If Abs(mdr(cldaim * 10, bodyaim * 10)) > 450 Then
                                shields = shields - e
                            End If
                        Else
                            shields = shields - e
                        End If
                        energyshield
                        cldenergy = .energy
                        .cldenergy = energy
                        speed = (speed + interface.desiredspeed) / 2
                        If speed > 10 Then speed = 10
                        If speed < -10 Then speed = -10
                    End If
                End With
            End If
        Next ii
        
        If gamespeed > 0 Or (turns And 1) = 0 Then
            eraseRobot
            drawRobot
        End If
    Else
        If RICount > 2 Then
        If cldid >= 0 And cldid <> Index Then
            With robots(cldid)
                If .dead = False Then
                    If team(Index) < 0 Or team(cldid) <> team(Index) Then
                        broadcast .interface.name + " killed " + interface.name + "."
                        If ScoringMethod = 0 Then .score = .score + RICount - 1
                        If ScoringMethod = 2 Then .score = .score + 1
                    Else
                        broadcast .interface.name + " killed his team mate " + interface.name + "."
                        If ScoringMethod = 0 Then .score = .score - RICount + 1
                        If ScoringMethod = 2 Then .score = .score - 1
                    End If
                End If
            End With
        ElseIf cldid = Index Then
            broadcast interface.name + " committed suicide."
        End If
        End If
        kill
    End If
End If
'MainForm.Label1.Caption = CStr(energy) + "  " + CStr(speed)
End Sub

Public Sub loadrobot(bot As String, ext As String)
working = True
Index = RICount
On Error Resume Next
If Index > 0 Then Load MainForm.sc(Index)
On Error GoTo 0
Set sc = MainForm.sc(Index)

If ext = "vbs" Or ext = "vbr" Then
        sc.Language = "VBScript"
        CLike = False
ElseIf ext = "js" Or ext = "jsr" Then
        sc.Language = "JScript"
        CLike = True
Else
    If InStr(LCase$(bot), "end sub") Or InStr(LCase$(bot), "end function") Then
        sc.Language = "VBScript"
        CLike = False
    Else
        sc.Language = "JScript"
        CLike = True
    End If
End If
If Not CLike Then
    bot = Replace(bot, "endif", "end if", , , vbTextCompare)
End If
Set interface = New RobotInterface
On Error Resume Next
sc.AddCode bot
If Err.Number > 0 Then
    MsgBox "Robot." + CStr(Index) + ": " + Err.Description, , "Robot Load Error"
    working = False
Else
    working = True
End If
On Error GoTo 0
End Sub

Private Function sl(i As Long)
sl = sinlook((i + 36000) Mod 360)
End Function

Private Function cl(i As Long)
cl = coslook((i + 36000) Mod 360)
End Function

Public Sub draw()
Dim i As Long, i2 As Long
If gamespeed >= 0 Then
If aWidth >= 4000 Then
Arena.Circle (ax, ay), Aszm * aWidth / 100, QBColor(9), , , ARatio
Else
Arena.ForeColor = interface.bodycolor
Arena.Circle (ax, ay), Aszm * 17, , wrap2(45 - bodyaim) * 3.14159265359 / 180, wrap2(135 - bodyaim) * 3.14159265359 / 180, ARatio
i = wrap2(bodyaim - 45)
i2 = wrap2(bodyaim - 135)
Arena.Line (ax + sinlook(i) * 17 \ 65536, ay - coslook(i) * 17 \ 65536)-(ax + sinlook(i2) * 17 \ 65536, ay - coslook(i2) * 17 \ 65536)
i = wrap2(bodyaim + 45)
i2 = wrap2(bodyaim + 135)
Arena.Line (ax + sinlook(i) * 17 \ 65536, ay - coslook(i) * 17 \ 65536)-(ax + sinlook(i2) * 17 \ 65536, ay - coslook(i2) * 17 \ 65536)
i = wrap2(bodyaim + 135)
i2 = wrap2(bodyaim - 135)
Arena.Line (ax + sinlook(i) * 17 \ 65536, ay - coslook(i) * 17 \ 65536)-(ax + sinlook(i2) * 17 \ 65536, ay - coslook(i2) * 17 \ 65536)

Arena.ForeColor = interface.guncolor
Arena.Line (ax, ay)-Step(sinlook(gunaim) \ 4096, -coslook(gunaim) \ 4096)
Arena.ForeColor = interface.radarcolor
i = (radaraim + 320) Mod 360
Arena.Line (ax, ay)-Step(sinlook(i) \ 8192, -coslook(i) \ 8192)
i = (radaraim + 40) Mod 360
Arena.Line (ax, ay)-Step(sinlook(i) \ 8192, -coslook(i) \ 8192)
End If
End If
End Sub


Public Sub drawRobot()
Arena.ForeColor = QBColor(0)
draw
px = ax
py = ay
pbodyaim = bodyaim
pgunaim = gunaim
pradaraim = radaraim
End Sub

Public Sub eraseRobot()
Arena.ForeColor = QBColor(15)
'draw
Dim i As Long, i2 As Long
If gamespeed >= 0 Then
If aWidth >= 4000 Then
Arena.Circle (px, py), Aszm * aWidth / 100, , , , ARatio
Else
Arena.Line (px, py)-Step(sinlook(pgunaim) \ 4096, -coslook(pgunaim) \ 4096)
i = (pradaraim + 320) Mod 360
Arena.Line (px, py)-Step(sinlook(i) \ 8192, -coslook(i) \ 8192)
i = (pradaraim + 40) Mod 360
Arena.Line (px, py)-Step(sinlook(i) \ 8192, -coslook(i) \ 8192)

Arena.Circle (px, py), Aszm * 17, , wrap2(45 - pbodyaim) * 3.14159265359 / 180, wrap2(135 - pbodyaim) * 3.14159265359 / 180, ARatio
i = wrap2(pbodyaim - 45)
i2 = wrap2(pbodyaim - 135)
Arena.Line (px + sinlook(i) * 17 \ 65536, py - coslook(i) * 17 \ 65536)-(px + sinlook(i2) * 17 \ 65536, py - coslook(i2) * 17 \ 65536)
i = wrap2(pbodyaim + 45)
i2 = wrap2(pbodyaim + 135)
Arena.Line (px + sinlook(i) * 17 \ 65536, py - coslook(i) * 17 \ 65536)-(px + sinlook(i2) * 17 \ 65536, py - coslook(i2) * 17 \ 65536)
i = wrap2(pbodyaim + 135)
i2 = wrap2(pbodyaim - 135)
Arena.Line (px + sinlook(i) * 17 \ 65536, py - coslook(i) * 17 \ 65536)-(px + sinlook(i2) * 17 \ 65536, py - coslook(i2) * 17 \ 65536)
End If
End If

End Sub


