Attribute VB_Name = "cmdlg"
'Written by David Finch <mef@wave.net>  ICQ #9869494

'Microsoft has released too many versions of comdlg32.ocx.


Option Explicit

Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
            hInstance As Long
        lpstrFilter As String
            lpstrCustomFilter As String
            nMaxCustFilter As Long
            nFilterIndex As Long
        lpstrFile As String
            nMaxFile As Long
        lpstrFileTitle As String
            nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
            flags As Long
        nFileOffset As Long
        nFileExtension As Long
        lpstrDefExt As String
            lCustData As Long
            lpfnHook As Long
            lpTemplateName As String
End Type




Global dlgfilename As String

Public Const OFN_READONLY = &H1
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_SHOWHELP = &H10
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_ALLOWMULTISELECT = &H200
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOLONGNAMES = &H40000                      '  force no long names for 4.x modules
Public Const OFN_EXPLORER = &H80000                         '  new look commdlg
Public Const OFN_NODEREFERENCELINKS = &H100000
Public Const OFN_LONGNAMES = &H200000                       '  force long names for 3.x modules

Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0

Dim ofn As OPENFILENAME

Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Function st(a, b)
a = b
st = b
End Function

Sub setfilter(f As String)
ofn.lpstrFile = ""
ofn.lpstrFilter = Replace$(f, "|", Chr$(0)) + Chr$(0) + Chr$(0)
End Sub

Sub resetpath()
    ofn.lpstrInitialDir = App.path
End Sub

Sub initdlg()
    ofn.lpstrFile = dlgfilename + Chr$(0) + String$(255, Asc(" "))
    ofn.nMaxFile = 254
    ofn.lStructSize = 76
    ofn.hwndOwner = Screen.ActiveForm.hWnd
    'Robots (*.rba)|*.rba|VBScript (*.vbs)|*.vbs|Text files (*.txt)|*.txt|All files (*.*)|*.*
    'ofn.lpstrFilter = "All files" + Chr$(0) + "*.*" + Chr$(0) + Chr$(0)
    ofn.lpstrDefExt = "rba"
    ofn.flags = &H1000
End Sub

Sub getfileinfo()
        Dim i As Long
        Dim a As String
        a = ofn.lpstrFile 'Left$(ofn.lpstrFile, ofn.nMaxFile)

        a = Trim$(Replace$(a, Chr$(0), " "))
        
        dlgfilename = a

    'later maybe add support for filetitle, path, extension...
End Sub

Sub getopen()
    initdlg
    ofn.lpstrTitle = "Choose robot to load"
    GetOpenFileName ofn
    getfileinfo
End Sub


Sub getsave()
    initdlg
    ofn.lpstrTitle = "Save file"
    GetSaveFileName ofn
    getfileinfo
End Sub

Sub getcustom(a As String)
    initdlg
    ofn.lpstrTitle = a
    GetSaveFileName ofn
    getfileinfo
End Sub


Sub getcustom2(a As String)
    initdlg
    ofn.lpstrTitle = a
    GetOpenFileName ofn
    getfileinfo
End Sub

Function ExtractName(path As String) As String
    Dim i As Long
    If st(i, InStrRev(path, "\")) Then
        ExtractName = Right$(path, Len(path) - i)
    Else
        ExtractName = path
    End If
End Function

Function ExtractDir(path As String) As String
    Dim i As Long
    If st(i, InStrRev(path, "\")) Then
        ExtractDir = Left$(path, i)
    Else
        ExtractDir = ""
    End If
End Function

