VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Robot match viewer"
   ClientHeight    =   5475
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4035
   ClipControls    =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5475
   ScaleWidth      =   4035
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000012&
      Height          =   1365
      Left            =   90
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   4050
      Width           =   3885
   End
   Begin VB.Timer Timer1 
      Interval        =   53
      Left            =   2880
      Top             =   1440
   End
   Begin VB.PictureBox Arena 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      ClipControls    =   0   'False
      ForeColor       =   &H80000008&
      Height          =   3870
      Left            =   90
      ScaleHeight     =   256
      ScaleMode       =   0  'User
      ScaleWidth      =   256
      TabIndex        =   0
      Top             =   90
      Width           =   3870
      Begin VB.Timer Timer2 
         Interval        =   500
         Left            =   1890
         Top             =   3240
      End
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Start"
      Height          =   465
      Left            =   1440
      TabIndex        =   1
      Top             =   1800
      Width           =   1185
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim ib As Long
Dim block(1024) As Byte
Dim bi As Long

Dim timein As Double

Dim dcount As Long, tcount As Long, speed As Long

Dim ftodo

Dim tmr As Double

Dim matchdone As Boolean

Dim botsize As Long, gunsize As Long, radarsize As Long, missilesize As Long

Private Type rbentry
    ax As Long
    ay As Long
    bodyaim As Long
    gunaim As Long
    radaraim As Long
End Type

Private Type mientry
    ax As Long
    ay As Long
End Type

Dim bots(100) As rbentry
Dim missiles(100) As mientry

Dim botcount As Long
Dim micount As Long

Dim slook(255) As Double
Dim clook(255) As Double

Dim file As String

Function wrap(a As Long) As Long
wrap = a And 255
End Function

Sub addtext(a As Long)
Static s As String
If a = 0 Then
    If Len(s) > 0 Then
        Text1.Text = Text1.Text + s
        Text1.SelStart = Len(Text1.Text) - 1
        s = ""
    End If
Else
    s = s + Chr$(a)
End If
End Sub

Sub addstring()
Dim i As Long
Do
i = nextbyte
addtext i
Loop Until i = 0
End Sub

Sub drawrobot(index As Long, color As Long)
Arena.ForeColor = color
With bots(index)
Arena.Circle (.ax, .ay), botsize, , wrap(32 - .bodyaim) * 3.14159265359 / 128, wrap(96 - .bodyaim) * 3.14159265359 / 128
Arena.Line (.ax, .ay)-Step(slook(.gunaim) * gunsize, -clook(.gunaim) * gunsize)
i = wrap(.radaraim + 228)
Arena.Line (.ax, .ay)-Step(slook(i) * radarsize, -clook(i) * radarsize)
i = wrap(.radaraim + 28)
Arena.Line (.ax, .ay)-Step(slook(i) * radarsize, -clook(i) * radarsize)
i = wrap(.bodyaim - 32)
i2 = wrap(.bodyaim - 96)
Arena.Line (.ax + slook(i) * botsize, .ay - clook(i) * botsize)-(.ax + slook(i2) * botsize, .ay - clook(i2) * botsize)
i = wrap(.bodyaim + 32)
i2 = wrap(.bodyaim + 96)
Arena.Line (.ax + slook(i) * botsize, .ay - clook(i) * botsize)-(.ax + slook(i2) * botsize, .ay - clook(i2) * botsize)
i = wrap(.bodyaim + 96)
i2 = wrap(.bodyaim - 96)
Arena.Line (.ax + slook(i) * botsize, .ay - clook(i) * botsize)-(.ax + slook(i2) * botsize, .ay - clook(i2) * botsize)
End With
End Sub

Sub drawmissile(index As Long, color As Long)
With missiles(index)
Arena.Circle (.ax, .ay), missilesize, color
End With
End Sub

Function max(a As Long, b As Long) As Long
If a < b Then max = b Else max = a
End Function

Function nextbyte() As Long
If ib = 0 Then
Open file For Binary As #2
Get #2, bi, block
Close #2
bi = bi + 1024
End If
nextbyte = block(ib)
ib = ib + 1
If ib > 1023 Then ib = 0
End Function

Sub nextblock()
Dim bcount As Long, mcount As Long, i As Long, mx As Long
botsize = nextbyte()
If botsize = 255 Then
    addstring
    matchdone = True
    Exit Sub
End If
gunsize = botsize * 16 \ 68
radarsize = botsize * 8 \ 68
missilesize = botsize * 3 \ 68
botsize = botsize \ 4
If missilesize < 1 Then
    missilesize = 1
    If radarsize < 1 Then
        radarsize = 1
        If gunsize < 1 Then
            gunsize = 1
            If botsize < 1 Then botsize = 1
        End If
    End If
End If
bcount = nextbyte()
mx = max(bcount, botcount)
For i = 0 To mx - 1
    If i < botcount Then drawrobot i, QBColor(15)
    If i < bcount Then
        With bots(i)
            .ax = nextbyte()
            .ay = nextbyte()
            .bodyaim = nextbyte()
            .radaraim = nextbyte()
            .gunaim = nextbyte()
        End With
        drawrobot i, QBColor(0)
    End If
Next i
botcount = bcount
mcount = nextbyte()
mx = max(mcount, micount)
For i = 0 To mx - 1
    If i < micount Then drawmissile i, QBColor(15)
    If i < mcount Then
        With missiles(i)
            .ax = nextbyte()
            .ay = nextbyte()
        End With
        drawmissile i, QBColor(0)
    End If
Next i
addstring
micount = mcount
End Sub



Private Sub Arena_Click()
Dim i As Long, spd As Long, td As Double, tc As Double
matchdone = False
i = tcount
tmr = Timer
While tcount = i: DoEvents: Wend
tcount = 0
bi = 1
While tcount = 0
DoEvents
dcount = dcount + 1
Wend
While Not matchdone
nextblock
tc = tc + 1 / 54.6
td = tc - Timer - timein + tmr
spd = speed * 1.5 ^ td
timein = timein + 1 / 54.6
If timein > 1 / 18.2 Then timein = 1 / 18.2
For i = 0 To spd
DoEvents
dcount = dcount + 1
Next i
Wend
End Sub

Private Sub Form_Load()
matchdone = True
Dim i As Long
bi = 1
For i = 0 To 255
    slook(i) = Sin(i * 3.1415926535859 / 128)
    clook(i) = Cos(i * 3.1415926535859 / 128)
Next i
setfilter "Match recordings (*.rec)|*.rec|All files (*.*)|*.*"
getcustom2 "Choose recording to playback"
file = dlgfilename
If file = "" Then End
Show
End Sub

Private Sub Form_Unload(Cancel As Integer)
End
End Sub

Private Sub Timer1_Timer()
timein = 0
tcount = tcount + 3
speed = dcount \ tcount
End Sub

Private Sub Command1_Click()
Arena_Click
End Sub

Private Sub Timer2_Timer()
If Not matchdone Then
Caption = "Robot match viewer - " + CStr(CLng(Timer - tmr)) + " seconds"
End If
End Sub
